vRPCminer = {}
Tunnel.bindInterface("vrp_miner",vRPCminer)
Proxy.addInterface("vrp_miner",vRPCminer)
vRP = Proxy.getInterface("vRP")
vRPSminer = Tunnel.getInterface("vrp_miner","vrp_miner")

local hasjob = false
local minereu = 0

local fontsLoaded = false
local font
AddEventHandler("playerSpawned",function()
Citizen.CreateThread(function()
    Citizen.Wait(1000)
        RegisterFontFile('wmk')
        font = RegisterFontId('Freedom Font')
        fontsLoaded = true
    end)
end)

function spargeminereu()
    local ped = PlayerPedId()
    local x, y, z = table.unpack(GetEntityCoords(ped))
    local user_id = vRP.getUserId({source})

    exports['progressbar']:Progress({
        name = "spargere_mina",
        duration = 35000, -- Durata în milisecunde (25 secunde)
        label = "Minezi...",
        useWhileDead = false,
        canCancel = true,
        controlDisables = {
            disableMovement = true,
            disableCarMovement = true,
            disableMouse = false,
            disableCombat = true
        },
        onCancel = function()
            ClearPedTasksImmediately(ped)
            FreezeEntityPosition(ped, false)
            DeleteObject(propaxe)
        end
    })

    while not HasAnimDictLoaded("melee@large_wpn@streamed_core") do 
        RequestAnimDict("melee@large_wpn@streamed_core")
        Citizen.Wait(1)
    end

    local propaxe = CreateObject(GetHashKey("prop_tool_pickaxe"), x, y, z + 0.2, true, true, true)
    AttachEntityToEntity(propaxe, ped, GetPedBoneIndex(ped, 57005), 0.08, -0.4, -0.10, 80.0, -20.0, 175.0, true, true, false, true, 1, true)
    TaskPlayAnim(ped, "melee@large_wpn@streamed_core", "ground_attack_on_spot", 8.0, 1.0, -1, 49, 0, 0, 0, 0)
    FreezeEntityPosition(ped, true)

    Citizen.Wait(35000)

    DeleteObject(propaxe)
    ClearPedTasksImmediately(ped)
    FreezeEntityPosition(ped, false)
    DetachEntity(propaxe, 1)
    DeleteObject(propaxe)

    vRPSminer.daiMinereu()
end


local function drawText(text, x, y, scale, r, g, b)
    SetTextFont(font)
    SetTextCentre(10)
    SetTextProportional(0)
    SetTextScale(scale, scale)
    SetTextDropShadow(1, 5, 5, 5, 255)
    SetTextEntry("STRING")
    SetTextColour(r, g, b, 255)
    AddTextComponentString(text)
    DrawText(x, y)
end

local function drawButton(x, y, width, height, text, hr, hg, rb, cb)

    local cursorX = GetDisabledControlNormal(0, 239)
    local cursorY = GetDisabledControlNormal(0, 240)

    local hover = false
    if x - (width/2) < cursorX and x + (width/2) > cursorX then
        if y - (height/2) < cursorY and y + (height/2) > cursorY then
            hover = true
        end
    end

    if hover then
        SetMouseCursorSprite(5)
        drawText(text, x, y-(height/2), 0.6, hr, hg, rb)
        DrawRect(x, y, width, height, 255, 255, 255, 200)
        if IsDisabledControlJustPressed(0, 24) then
            cb()
        end
    else
        drawText(text, x, y-(height/2), 0.6, 80, 80, 80)
        DrawRect(x, y, width, height, 255, 255, 255, 100)
    end
end

local function startMinerGui()


    guiOn = true

    local effect = "MenuMGHeist"
    StartScreenEffect(effect.."In", 0, true)

    while guiOn do

        if IsDisabledControlJustPressed(0, 177) then
            guiOn = false
        end

        SetMouseCursorActiveThisFrame()
        SetMouseCursorSprite(1)
        for i=0, 31 do
            DisableAllControlActions(i)
        end
        EnableControlAction(0, 249, true)
        EnableControlAction(0, 246, true) 
        EnableControlAction(3, 177, true) 
        EnableControlAction(0, 11, true)
        EnableControlAction(0, 167, true)

        drawText("~w~Job Miner", 0.5, 0.36, 0.4, 255, 255, 255)

        DrawRect(0.25, 0.5, 0.2, 0.15, 138, 138, 138, 100)
        drawText("~w~Incepe~w~ Munca", 0.25, 0.45, 0.4, 255, 255, 255)
        drawButton(0.25, 0.52, 0.1, 0.05, "Incepe", 255, 255, 255, function()
        vRPSminer.verificaGrad({""}, function(areGrad)
            if areGrad then
                hasjob = true
                SetNewWaypoint(2937.1337890625,2790.6784667969,40.186328887939)
                vRP.notify({"Ti-a fost setata locatia pe GPS"})
                guiOn = false
            else
                vRPSminer.verificaore({1}, function(are)
                    if are then
                        hasjob = true
                            SetNewWaypoint(2937.1337890625,2790.6784667969,40.186328887939)
                            vRP.notify({"Ti-a fost setata locatia pe GPS"})
                            guiOn = false
                        else
                            guiOn = false
                        end
                    end)
                end
            end)
        end)

        DrawRect(0.75, 0.5, 0.2, 0.15, 138, 138, 138, 100)
        drawText("Termina~w~ Munca", 0.75, 0.45, 0.4, 255, 255, 255)
        drawButton(0.75, 0.52, 0.1, 0.05, "Termina", 255, 255, 255, function()
            hasjob = false
            guiOn = false
        end)

        Citizen.Wait(1)
    end

    StopScreenEffect(effect.."In")
    StartScreenEffect(effect.."Out", 800, false)
end

local coordonate = {
    vector3(2927.2795410156,2792.3332519531,40.483276367188),
    vector3(2935.4711914063,2784.5971679688,39.539321899414),
    vector3(2938.3288574219,2770.9729003906,39.15336227417),
    vector3(2951.3142089844,2769.0822753906,39.03462600708),
    vector3(2966.7863769531,2775.6345214844,38.830333709717),
    vector3(2975.7275390625,2792.6000976563,40.653316497803),
}

Citizen.CreateThread(function()
    ticks = 1000
    while true do
        local pos = GetEntityCoords(ped)
        ped = PlayerPedId()
        if hasjob == true then
            for i,v in pairs(coordonate) do
                if #(GetEntityCoords(ped) - vector3(v[1],v[2],v[3])) <= 50.0 then
                ticks = 1
                drawtotal(v[1], v[2], v[3] -1.800, "~HUD_COLOUR_NET_PLAYER13~Misiune\n~w~Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~] ~w~ pentru a ~HUD_COLOUR_NET_PLAYER13~sparge minereul", 4, 0.1, 0.1)
                if coordonate[i] ~= nil then
                    if #(GetEntityCoords(ped) - vector3(v[1],v[2],v[3])) <= 3.0 then
                        ticks = 1
                        if IsControlJustPressed(1,51) and not IsPedInAnyVehicle(ped, false) then
                            vRPSminer.arePickaxe({},function(are)
                                if are then
                                    table.remove(coordonate,i)
                                    spargeminereu()
                                    SetTimeout(1000, function()
                                    minereu = minereu + 1
                                        if minereu == 6 then
                                            Citizen.Wait(10000)
                                            table.insert(coordonate,{2927.2795410156,2792.3332519531,40.483276367188})
                                            table.insert(coordonate,{2935.4711914063,2784.5971679688,39.539321899414})
                                            table.insert(coordonate,{2951.3142089844,2769.0822753906,39.03462600708})
                                            table.insert(coordonate,{2938.3288574219,2770.9729003906,39.15336227417})
                                            table.insert(coordonate,{2966.7863769531,2775.6345214844,38.830333709717})
                                            table.insert(coordonate,{2975.7275390625,2792.6000976563,40.653316497803})
                                            minereu = 0
                                        end
                                    end)
                                end
                            end)
                        end
                    end
                else
                    vRP.notify({"Minereurile au fost deja sparte",4000,3})
                end
            end
        end
    end
        if #(GetEntityCoords(ped) - vector3(2946.9289550781,2747.3852539063,43.413429260254)) <= 5.0 then
            drawtotal( 2946.9289550781,2747.3852539063,43.413429260254 -1.800, "~HUD_COLOUR_NET_PLAYER13~Miner Job\n~w~Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~] ~w~ pentru a incepe ~HUD_COLOUR_NET_PLAYER13~munca", 4, 0.1, 0.1)
            ticks = 1
            if IsControlJustPressed(1,51) then
                startMinerGui()
            end
        end
        if #(GetEntityCoords(ped) - vector3(1109.3162841796,-2007.72265625,31.03109741211)) <= 5.0 then
            drawtotal( 1109.3162841796,-2007.72265625,31.03109741211 -1.800, "~HUD_COLOUR_NET_PLAYER13~Vanzare Minereuri\n~w~Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~] ~w~ pentru a vinde ~HUD_COLOUR_NET_PLAYER13~minereuri", 4, 0.1, 0.1)
            ticks = 1
            if IsControlJustPressed(1,51) then
                vRPSminer.vindeMinereu()
            end
        end

        Citizen.Wait(ticks)
        ticks = 1000
    end
end)